;=========================================================
;
; "Green Phosphor 153b (153+2 bytes)"
; a crappy ROM font to "green phosphor" multicolor
; sprites font renderer gadget thingamagic
; (C) Copyright 2019 ccr/TNSP^PWP <ccr@tnsp.org>
;
; This code is licensed under WTFPL (see COPYING.txt)
;
; This code is in XA compatible assembler format.
;
; This is meant to be used in conjunction with vw_phosphor.bin
; by Shadow, which is linked into phosphor.prg
;
;=========================================================
#define MEGA_OPTIM

	orig_01			= $37
	spr_data		= $2000	; pointer to sprite data
	chr_data		= $d000	; character ROM address when enabled

	zp_start        = $a0

	spr_ptr			= zp_start + 0
	chr_ptr			= zp_start + 2
	tmpbyte 		= zp_start + 4
	save_y			= zp_start + 5
	spr_bcount		= zp_start + 6
	spr_tmp			= zp_start + 7


;=========================================================

	orig = $0900
	.word orig
	* = orig

;=========================================================

m_start:
	; Set memory config so that we can read from character ROM
	lda #$33
	sta $01

	; Initialize data pointers
#ifdef MEGA_OPTIM
	lda #0
	sta spr_ptr
	sta chr_ptr
#else
	lda #<chr_data
	sta chr_ptr
	lda #<spr_data
	sta spr_ptr
#endif

	lda #>spr_data
	sta spr_ptr + 1
	lda #>chr_data
	sta chr_ptr + 1

	; Render the characters
m_loop:

	; Render one character to sprite
	ldy #0
m_yloop:
	jsr b_draw_line
	jsr b_draw_line
	jsr b_draw_empty_line
	
	iny
	cpy #7
	bne m_yloop

	; Sprite data pointer 63, add 1
	jsr m_inc_spr_ptr

	; Add 8 to char data pointer
	lda chr_ptr
	clc
	adc #8
	sta chr_ptr
	bcc m_noc
	inc chr_ptr + 1
m_noc:

	; Loop until done
	dec font_counter
	bne m_loop

#ifndef MEGA_OPTIM
	; Restore memory configuration
	lda #orig_01
	sta $01
#endif

	; To save space and one rts, have this here
m_inc_spr_ptr:
	lda spr_ptr
	clc
	adc #1
	sta spr_ptr
	bcc m_noinc
	inc spr_ptr + 1

m_noinc:
	rts

;=========================================================

b_draw_empty_line:
	sty save_y
	jsr b_draw_empty_byte
	jsr b_draw_empty_byte

b_draw_empty_byte:
	ldy #0
	tya
	sta (spr_ptr), y
	jsr m_inc_spr_ptr
	ldy save_y
	rts

;=========================================================

b_draw_line:
	ldx #7
	lda #0
	sta spr_tmp
	stx spr_bcount

b_xloop:
	lda (chr_ptr), y
	and tbl_bitmasks, x
	sta tmpbyte

	jsr b_draw_bit
	jsr b_draw_bit
	jsr b_zero

	dex
	bpl b_xloop
	rts

;=========================================================

b_draw_bit:
	sty save_y

	lda tmpbyte
	beq b_zero

	sec
	bcs b_draw

b_zero:
	clc

b_draw:
	rol spr_tmp
	lda spr_tmp

	ldy spr_bcount
	dey
	bne b_not_full

	; Y = 0
	sta (spr_ptr), y
	jsr m_inc_spr_ptr
	ldy #7
	
b_not_full:
	sty spr_bcount
	ldy save_y
	rts

	
;=========================================================
; Data
;=========================================================
tbl_bitmasks:	.byte 0, $01, $02, $04, $08, $10, $20, $40, $80
font_counter:	.byte 64
